package org.zkforge.zktodo2;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

@Entity
@Table(name = "REMINDER")
public class Reminder {
	@Override
	public boolean equals(Object obj) {
		if( obj instanceof Reminder ){
			Reminder other = (Reminder) obj;
			if( this.getId() != null && other.getId() != null && this.getId().equals(other.getId())){
				return true;
			}
		}
		return false;
	}
	@Override
	public int hashCode() {
		return Long.valueOf(this.getId()).hashCode();
	}
	@Id @GeneratedValue
	@Column(name = "REMINDER_ID")
	private Long id;
	
	@Column(name = "NAME")
	private String name;
	
	@Column(name = "PRIORITY")
	private int priority;
	
	@Column(name = "DATE")
	private Date date;
	
	public Reminder(){}
	public Reminder(String name,int priority,Date date){
		this.name = name;
		this.priority = priority;
		this.date = date;
	}
	public Date getDate() {
		return date;
	}
	public void setDate(Date date) {
		this.date = date;
	}
	public int getPriority() {
		return priority;
	}
	public void setPriority(int priority) {
		this.priority = priority;
	}
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
}
