package org.zkforge.zktodo2;

import java.util.List;

public class ZkToDoModelImpl implements ZkToDoModel {
	protected ReminderService reminderService;

	/* (non-Javadoc)
	 * @see org.zkforge.zktodo2.ZkToDoModel#deleteEvent(org.zkforge.zktodo2.Reminder)
	 */
	public void deleteEvent(Reminder reminder) throws EntityNotFoundException {
		reminderService.deleteEvent(reminder);
	}

	/* (non-Javadoc)
	 * @see org.zkforge.zktodo2.ZkToDoModel#findAll()
	 */
	public List<Reminder> findAll() {
		return reminderService.findAll();
	}

	/* (non-Javadoc)
	 * @see org.zkforge.zktodo2.ZkToDoModel#mergeEvent(org.zkforge.zktodo2.Reminder)
	 */
	public void mergeEvent(Reminder reminder) throws EntityNotFoundException {
		reminderService.mergeEvent(reminder);
	}

	/* (non-Javadoc)
	 * @see org.zkforge.zktodo2.ZkToDoModel#persistEvent(org.zkforge.zktodo2.Reminder)
	 */
	public void persistEvent(Reminder reminder) {
		reminderService.persistEvent(reminder);
	}

	public ReminderService getReminderService() {
		return reminderService;
	}

	public void setReminderService(ReminderService reminderService) {
		this.reminderService = reminderService;
	}
	
	protected Reminder selectedReminder = null;

	//used by selectedItem="@{controller.selectedReminder}" and others
	/* (non-Javadoc)
	 * @see org.zkforge.zktodo2.ZkToDoModel#getSelectedReminder()
	 */
	public Reminder getSelectedReminder() {
		return this.selectedReminder;
	}
	
	//used by selectedItem="@{controller.selectedReminder}" and others
	/* (non-Javadoc)
	 * @see org.zkforge.zktodo2.ZkToDoModel#setSelectedReminder(org.zkforge.zktodo2.Reminder)
	 */
	public void setSelectedReminder(Reminder reminder) {
		this.selectedReminder = reminder;
	}
	
	//used by model="@{controller.reminders}"
	/* (non-Javadoc)
	 * @see org.zkforge.zktodo2.ZkToDoModel#getReminders()
	 */
	public List<Reminder> getReminders() {
		return this.findAll();
	}
}
